﻿//////////////////////////////////////////////
// ScriptWrapper.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkScripts
{
	class Environment ;
}

/// Includes ---------------------------------

// nkAstraeus
#include "../../../../Dll/DllDefines.h"

// nkScripts
#include <NilkinsScripts/Environments/Functions/Function.h>

/// Class ------------------------------------

namespace nkAstraeus::lua::nkScriptsWrap
{
	class DLL_ASTRAEUS_EXPORT ScriptWrapper final
	{
		private :

			// Constructeur, destructeur
			ScriptWrapper () = delete ;
			~ScriptWrapper () = delete ;

		public :

			// Env
			static void updateEnvironment (nkScripts::Environment* env) ;

			// Callbacks
			// Constructeur, destructeur
			static void* constructor (const nkScripts::DataStack& stack) ;
			static void destructor (void* toDestroy) ;
			// Getters
			static nkScripts::OutputValue getSources (const nkScripts::DataStack& stack) ;
			// Setters
			static nkScripts::OutputValue setSources (const nkScripts::DataStack& stack) ;
			// Loading
			static nkScripts::OutputValue load (const nkScripts::DataStack& stack) ;
			// Global
			static nkScripts::OutputValue call (const nkScripts::DataStack& stack) ;
	} ;
}