﻿//////////////////////////////////////////////
// ConfigHolder.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkGraphics
#include "RenderDescriptor.h"
#include "WindowDescriptor.h"

#include "../Dll/DllDefines.h"

#include "../Renderers/RenderingApi.h"

/// Class ------------------------------------
	
namespace nkGraphics
{
	class DLL_GRAPHICS_EXPORT ConfigHolder final
	{
		public :

			// Attributs
			// Paramètres de la fenêtre
			WindowDescriptor _window ;
			// Paramètres de rendu
			RenderDescriptor _rendering ;

			// Api voulue
			RENDERING_API _wantedApi ;
			// Api choisie
			RENDERING_API _chosenApi ;

		public :
		
			// Constructeur, destructeur
			ConfigHolder () ;
			~ConfigHolder () ;

			// Descriptions
			nkMemory::String graphicDescription () ;
			nkMemory::String renderDescription () ;
	} ;
}