﻿//////////////////////////////////////////////
// ScriptManager.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkScripts
{
	class Script ;
}

/// Includes ---------------------------------

// nkScripts
#include "../Dll/DllDefines.h"

// nkCommon
#include <nilkinsCommon/Patterns/SingletonClass.h>

// nkMemory
#include <NilkinsMemory/Containers/StringView.h>

// Standards
#include <string>
#include <unordered_map>

/// Class ------------------------------------

namespace nkScripts
{
	class DLL_SCRIPTS_EXPORT ScriptManager final : public nkCommon::SingletonClass<ScriptManager>
	{
		friend class nkCommon::SingletonClass<ScriptManager> ;

		private :

			// Attributes
			// Map des scripts
			std::unordered_map<std::string, Script*> _scriptMap ;

		private :

			// Functions
			// Constructeur, destructeur
			ScriptManager () ;
			~ScriptManager () ;

		public :

			// Manipulation map
			Script* createOrRetrieve (const nkMemory::StringView& name) ;
			Script* get (const nkMemory::StringView& name) ;
			Script* getByIndex (unsigned int id) ;
			void rename (const nkMemory::StringView& currentName, const nkMemory::StringView& newName) ;
			void erase (const nkMemory::StringView& name) ;
	} ;
}