﻿//////////////////////////////////////////////
// Window.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkImages
{
	class ImageView ;
}

namespace nkWinUi
{
	class MenuBar ;
}

/// Includes ---------------------------------

// nkWinUi
#include "../Dll/DllDefines.h"

#include "../Inputs/CallbackRepository.h"

#include "Component.h"

/// Class ------------------------------------
	
namespace nkWinUi
{
	class DLL_WINUI_EXPORT Window : public Component
	{
		protected :

			// Attributes
			// Callback for clicks
			mouseClickCallback _clickCallback ;

		public :
		
			// Constructor, destructor
			Window () ;
			~Window () ;

			// Getters
			virtual bool isMaximized () const ;
			virtual bool isFullscreen () const ;

			// Setters
			void setClickCallback (const mouseClickCallback& value) ;
			virtual void setIcon (const nkImages::ImageView& icon) = 0 ;

			// Size
			virtual void maximize (bool val, bool coverTaskBar = false) = 0 ;

			// Import / Export
			virtual void exportIntrospection (nkExport::Node* rootNode) override ;
			virtual void importClassFromTree (nkExport::Node* rootNode) override ;
	} ;
}